Index: sasmodels/kernel_iq.c
===================================================================
--- sasmodels/kernel_iq.c	(revision ec8d4acf126bf6a5404bc968d4eea25959657b12)
+++ sasmodels/kernel_iq.c	(revision dc6f601ca60f7d630a484562e056a94ed48bae82)
@@ -79,19 +79,22 @@
 //     du * (m_sigma_y + 1j*m_sigma_z);
 // weights for spin crosssections: dd du real, ud real, uu, du imag, ud imag
-static void set_spin_weights(double in_spin, double out_spin, double spins[4])
+static void set_spin_weights(double in_spin, double out_spin, double weight[6])
 {
   in_spin = clip(in_spin, 0.0, 1.0);
   out_spin = clip(out_spin, 0.0, 1.0);
-  spins[0] = sqrt(sqrt((1.0-in_spin) * (1.0-out_spin))); // dd
-  spins[1] = sqrt(sqrt((1.0-in_spin) * out_spin));       // du real
-  spins[2] = sqrt(sqrt(in_spin * (1.0-out_spin)));       // ud real
-  spins[3] = sqrt(sqrt(in_spin * out_spin));             // uu
-  spins[4] = spins[1]; // du imag
-  spins[5] = spins[2]; // ud imag
+  // Note: sasview 3.1 scaled all slds by sqrt(weight) and assumed that
+  //     w*I(q, rho1, rho2, ...) = I(q, sqrt(w)*rho1, sqrt(w)*rho2, ...)
+  // which is likely to be the case for simple models.
+  weight[0] = sqrt((1.0-in_spin) * (1.0-out_spin)); // dd
+  weight[1] = sqrt((1.0-in_spin) * out_spin);       // du.real
+  weight[2] = sqrt(in_spin * (1.0-out_spin));       // ud.real
+  weight[3] = sqrt(in_spin * out_spin);             // uu
+  weight[4] = weight[1]; // du.imag
+  weight[5] = weight[2]; // ud.imag
 }
 
 // Compute the magnetic sld
 static double mag_sld(
-  const int xs, // 0=dd, 1=du real, 2=ud real, 3=uu, 4=du imag, 5=up imag
+  const unsigned int xs, // 0=dd, 1=du.real, 2=ud.real, 3=uu, 4=du.imag, 5=ud.imag
   const double qx, const double qy,
   const double px, const double py,
@@ -103,18 +106,19 @@
     const double perp = qy*mx - qx*my;
     switch (xs) {
+      default: // keep compiler happy; condition ensures xs in [0,1,2,3]
       case 0: // uu => sld - D M_perpx
           return sld - px*perp;
-      case 1: // ud real => -D M_perpy
+      case 1: // ud.real => -D M_perpy
           return py*perp;
-      case 2: // du real => -D M_perpy
+      case 2: // du.real => -D M_perpy
           return py*perp;
-      case 3: // dd real => sld + D M_perpx
+      case 3: // dd => sld + D M_perpx
           return sld + px*perp;
     }
   } else {
     if (xs== 4) {
-      return -mz;  // ud imag => -D M_perpz
+      return -mz;  // du.imag => +D M_perpz
     } else { // index == 5
-      return mz;   // du imag => D M_perpz
+      return +mz;  // ud.imag => -D M_perpz
     }
   }
@@ -172,5 +176,5 @@
 // Apply the rotation matrix returned from qac_rotation to the point (qx,qy),
 // returning R*[qx,qy]' = [qa,qc]'
-static double
+static void
 qac_apply(
     QACRotation *rotation,
@@ -245,5 +249,5 @@
 // Apply the rotation matrix returned from qabc_rotation to the point (qx,qy),
 // returning R*[qx,qy]' = [qa,qb,qc]'
-static double
+static void
 qabc_apply(
     QABCRotation *rotation,
@@ -311,7 +315,7 @@
   //     up_angle = values[NUM_PARS+4];
   // TODO: could precompute more magnetism parameters before calling the kernel.
-  double spins[8];  // uu, ud real, du real, dd, ud imag, du imag, fill, fill
+  double xs_weights[8];  // uu, ud real, du real, dd, ud imag, du imag, fill, fill
   double cos_mspin, sin_mspin;
-  set_spin_weights(values[NUM_PARS+2], values[NUM_PARS+3], spins);
+  set_spin_weights(values[NUM_PARS+2], values[NUM_PARS+3], xs_weights);
   SINCOS(-values[NUM_PARS+4]*M_PI_180, sin_mspin, cos_mspin);
 #endif // MAGNETIC
@@ -659,6 +663,6 @@
 
             // loop over uu, ud real, du real, dd, ud imag, du imag
-            for (int xs=0; xs<6; xs++) {
-              const double xs_weight = spins[xs];
+            for (unsigned int xs=0; xs<6; xs++) {
+              const double xs_weight = xs_weights[xs];
               if (xs_weight > 1.e-8) {
                 // Since the cross section weight is significant, set the slds
@@ -673,4 +677,6 @@
                   local_values.vector[sld_index] =
                     mag_sld(xs, qx, qy, px, py, values[sld_index+2], mx, my, mz);
+//if (q_index==0) printf("%d: (qx,qy)=(%g,%g) xs=%d sld%d=%g p=(%g,%g) m=(%g,%g,%g)\n",
+//  q_index, qx, qy, xs, sk, local_values.vector[sld_index], px, py, mx, my, mz);
                 }
                 scattering += xs_weight * CALL_KERNEL();
Index: sasmodels/kernelcl.py
===================================================================
--- sasmodels/kernelcl.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/kernelcl.py	(revision d86f0fc0fff835c5ddf398e64c046518fa4536fc)
@@ -58,16 +58,18 @@
 import numpy as np  # type: ignore
 
+
+# Attempt to setup opencl. This may fail if the opencl package is not
+# installed or if it is installed but there are no devices available.
 try:
-    #raise NotImplementedError("OpenCL not yet implemented for new kernel template")
     import pyopencl as cl  # type: ignore
+    from pyopencl import mem_flags as mf
+    from pyopencl.characterize import get_fast_inaccurate_build_options
     # Ask OpenCL for the default context so that we know that one exists
     cl.create_some_context(interactive=False)
+    HAVE_OPENCL = True
+    OPENCL_ERROR = ""
 except Exception as exc:
-    warnings.warn("OpenCL startup failed with ***"
-                  + str(exc) + "***; using C compiler instead")
-    raise RuntimeError("OpenCL not available")
-
-from pyopencl import mem_flags as mf
-from pyopencl.characterize import get_fast_inaccurate_build_options
+    HAVE_OPENCL = False
+    OPENCL_ERROR = str(exc)
 
 from . import generate
@@ -102,6 +104,6 @@
         cl._DEFAULT_INCLUDE_OPTIONS = [quote_path(v) for v in cl._DEFAULT_INCLUDE_OPTIONS]
 
-fix_pyopencl_include()
-
+if HAVE_OPENCL:
+    fix_pyopencl_include()
 
 # The max loops number is limited by the amount of local memory available
@@ -128,6 +130,15 @@
 """
 
+def use_opencl():
+    return HAVE_OPENCL and os.environ.get("SAS_OPENCL", "").lower() != "none"
 
 ENV = None
+def reset_environment():
+    """
+    Call to create a new OpenCL context, such as after a change to SAS_OPENCL.
+    """
+    global ENV
+    ENV = GpuEnvironment() if use_opencl() else None
+
 def environment():
     # type: () -> "GpuEnvironment"
@@ -137,7 +148,11 @@
     This provides an OpenCL context and one queue per device.
     """
-    global ENV
     if ENV is None:
-        ENV = GpuEnvironment()
+        if not HAVE_OPENCL:
+            raise RuntimeError("OpenCL startup failed with ***"
+                               + OPENCL_ERROR + "***; using C compiler instead")
+        reset_environment()
+        if ENV is None:
+            raise RuntimeError("SAS_OPENCL=None in environment")
     return ENV
 
@@ -193,7 +208,7 @@
     Build a model to run on the gpu.
 
-    Returns the compiled program and its type.  The returned type will
-    be float32 even if the desired type is float64 if any of the
-    devices in the context do not support the cl_khr_fp64 extension.
+    Returns the compiled program and its type.
+
+    Raises an error if the desired precision is not available.
     """
     dtype = np.dtype(dtype)
Index: sasmodels/kerneldll.py
===================================================================
--- sasmodels/kerneldll.py	(revision 1ddb794c41646e0529a2f0ed64f654f04e7364c8)
+++ sasmodels/kerneldll.py	(revision 33969b656596e8b6cc8ce934cd1f8062f7b11cf2)
@@ -123,5 +123,8 @@
     # add openmp support if not running on a mac
     if sys.platform != "darwin":
-        CC.append("-fopenmp")
+        # OpenMP seems to be broken on gcc 5.4.0 (ubuntu 16.04.9)
+        # Shut it off for all unix until we can investigate.
+        #CC.append("-fopenmp")
+        pass
     def compile_command(source, output):
         """unix compiler command"""
@@ -158,13 +161,6 @@
         return CC + [source, "-o", output, "-lm"]
 
-# Windows-specific solution
-if os.name == 'nt':
-    # Assume the default location of module DLLs is in .sasmodels/compiled_models.
-    DLL_PATH = os.path.join(os.path.expanduser("~"), ".sasmodels", "compiled_models")
-    if not os.path.exists(DLL_PATH):
-        os.makedirs(DLL_PATH)
-else:
-    # Set up the default path for compiled modules.
-    DLL_PATH = tempfile.gettempdir()
+# Assume the default location of module DLLs is in .sasmodels/compiled_models.
+DLL_PATH = os.path.join(os.path.expanduser("~"), ".sasmodels", "compiled_models")
 
 ALLOW_SINGLE_PRECISION_DLLS = True
@@ -234,5 +230,5 @@
 
     Set *sasmodels.kerneldll.DLL_PATH* to the compiled dll output path.
-    The default is the system temporary directory.
+    The default is in ~/.sasmodels/compiled_models.
     """
     if dtype == F16:
@@ -251,4 +247,7 @@
         need_recompile = dll_time < newest_source
     if need_recompile:
+        # Make sure the DLL path exists
+        if not os.path.exists(DLL_PATH):
+            os.makedirs(DLL_PATH)
         basename = splitext(os.path.basename(dll))[0] + "_"
         system_fd, filename = tempfile.mkstemp(suffix=".c", prefix=basename)
Index: sasmodels/mixture.py
===================================================================
--- sasmodels/mixture.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/mixture.py	(revision ecf895e58d2474f33943e2931dfdca4633a22dc8)
@@ -94,8 +94,8 @@
             # If model is a sum model, each constituent model gets its own scale parameter
             scale_prefix = prefix
-            if prefix == '' and part.operation == '*':
+            if prefix == '' and getattr(part, "operation", '') == '*':
                 # `part` is a composition product model. Find the prefixes of
-                # it's parameters to form a new prefix for the scale, eg:
-                # a model with A*B*C will have ABC_scale
+                # it's parameters to form a new prefix for the scale.
+                # For example, a model with A*B*C will have ABC_scale.
                 sub_prefixes = []
                 for param in part.parameters.kernel_parameters:
@@ -233,5 +233,5 @@
         return self
 
-    def next(self):
+    def __next__(self):
         # type: () -> Tuple[List[Callable], CallDetails, np.ndarray]
         if self.part_num >= len(self.parts):
@@ -251,4 +251,7 @@
 
         return kernel, call_details, values
+
+    # CRUFT: py2 support
+    next = __next__
 
     def _part_details(self, info, par_index):
Index: sasmodels/model_test.py
===================================================================
--- sasmodels/model_test.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/model_test.py	(revision 3221de0ed9b3480163246ceb0503432126bd5134)
@@ -62,4 +62,5 @@
 from .exception import annotate_exception
 from .modelinfo import expand_pars
+from .kernelcl import use_opencl
 
 # pylint: disable=unused-import
@@ -123,5 +124,5 @@
 
         if is_py:  # kernel implemented in python
-            test_name = "Model: %s, Kernel: python"%model_name
+            test_name = "%s-python"%model_name
             test_method_name = "test_%s_python" % model_info.id
             test = ModelTestCase(test_name, model_info,
@@ -134,6 +135,6 @@
 
             # test using dll if desired
-            if 'dll' in loaders or not core.HAVE_OPENCL:
-                test_name = "Model: %s, Kernel: dll"%model_name
+            if 'dll' in loaders or not use_opencl():
+                test_name = "%s-dll"%model_name
                 test_method_name = "test_%s_dll" % model_info.id
                 test = ModelTestCase(test_name, model_info,
@@ -145,6 +146,6 @@
 
             # test using opencl if desired and available
-            if 'opencl' in loaders and core.HAVE_OPENCL:
-                test_name = "Model: %s, Kernel: OpenCL"%model_name
+            if 'opencl' in loaders and use_opencl():
+                test_name = "%s-opencl"%model_name
                 test_method_name = "test_%s_opencl" % model_info.id
                 # Using dtype=None so that the models that are only
@@ -160,5 +161,4 @@
 
     return suite
-
 
 def _hide_model_case_from_nose():
@@ -368,5 +368,5 @@
 
     # Build a test suite containing just the model
-    loaders = ['opencl'] if core.HAVE_OPENCL else ['dll']
+    loaders = ['opencl'] if use_opencl() else ['dll']
     models = [model]
     try:
@@ -425,5 +425,5 @@
         verbosity = 1
     if models and models[0] == 'opencl':
-        if not core.HAVE_OPENCL:
+        if not use_opencl():
             print("opencl is not available")
             return 1
@@ -435,8 +435,8 @@
         models = models[1:]
     elif models and models[0] == 'opencl_and_dll':
-        loaders = ['opencl', 'dll'] if core.HAVE_OPENCL else ['dll']
+        loaders = ['opencl', 'dll'] if use_opencl() else ['dll']
         models = models[1:]
     else:
-        loaders = ['opencl', 'dll'] if core.HAVE_OPENCL else ['dll']
+        loaders = ['opencl', 'dll'] if use_opencl() else ['dll']
     if not models:
         print("""\
@@ -467,15 +467,25 @@
     Run "nosetests sasmodels" on the command line to invoke it.
     """
-    loaders = ['opencl', 'dll'] if core.HAVE_OPENCL else ['dll']
+    loaders = ['opencl', 'dll'] if use_opencl() else ['dll']
     tests = make_suite(loaders, ['all'])
-    for test_i in tests:
-        # In order for nosetest to see the correct test name, need to set
-        # the description attribute of the returned function.  Since we
-        # can't do this for the returned instance, wrap it in a lambda and
-        # set the description on the lambda.  Otherwise we could just do:
-        #    yield test_i.run_all
-        L = lambda: test_i.run_all()
-        L.description = test_i.test_name
-        yield L
+    def build_test(test):
+        # In order for nosetest to show the test name, wrap the test.run_all
+        # instance in function that takes the test name as a parameter which
+        # will be displayed when the test is run.  Do this as a function so
+        # that it properly captures the context for tests that captured and
+        # run later.  If done directly in the for loop, then the looping
+        # variable test will be shared amongst all the tests, and we will be
+        # repeatedly testing vesicle.
+
+        # Note: in sasview sas.sasgui.perspectives.fitting.gpu_options
+        # requires that the test.description field be set.
+        wrap = lambda: test.run_all()
+        wrap.description = test.test_name
+        return wrap
+        # The following would work with nosetests and pytest:
+        #     return lambda name: test.run_all(), test.test_name
+
+    for test in tests:
+        yield build_test(test)
 
 
Index: sasmodels/modelinfo.py
===================================================================
--- sasmodels/modelinfo.py	(revision 5ab99b7733c7a08b8ef5bf95cdbd369b3b0a046a)
+++ sasmodels/modelinfo.py	(revision 95498a34dd5bf649c8e35fa888ca2bbdab9f3d77)
@@ -74,4 +74,5 @@
         processed.append(parse_parameter(*p))
     partable = ParameterTable(processed)
+    partable.check_angles()
     return partable
 
@@ -426,5 +427,4 @@
         # type: (List[Parameter]) -> None
         self.kernel_parameters = parameters
-        self._check_angles()
         self._set_vector_lengths()
 
@@ -476,5 +476,8 @@
         self.pd_2d = set(p.name for p in self.call_parameters if p.polydisperse)
 
-    def _check_angles(self):
+    def check_angles(self):
+        """
+        Check that orientation angles are theta, phi and possibly psi.
+        """
         theta = phi = psi = -1
         for k, p in enumerate(self.kernel_parameters):
@@ -499,7 +502,7 @@
             if psi >= 0 and psi != phi+1:
                 raise TypeError("psi must follow phi")
-            #if (psi >= 0 and psi != last_par) or (psi < 0 and phi != last_par):
-            #    raise TypeError("orientation parameters must appear at the "
-            #                    "end of the parameter table")
+            if (psi >= 0 and psi != last_par) or (psi < 0 and phi != last_par):
+                raise TypeError("orientation parameters must appear at the "
+                                "end of the parameter table")
         elif theta >= 0 or phi >= 0 or psi >= 0:
             raise TypeError("oriented shapes must have both theta and phi and maybe psi")
Index: sasmodels/models/core_shell_bicelle_elliptical.py
===================================================================
--- sasmodels/models/core_shell_bicelle_elliptical.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/models/core_shell_bicelle_elliptical.py	(revision fc3ae1b048f9f1a5decf2a1e56be7ff62491e36b)
@@ -9,5 +9,4 @@
 scattering length densities. The form factor is normalized by the total
 particle volume.
-
 
 .. figure:: img/core_shell_bicelle_geometry.png
@@ -91,10 +90,9 @@
 for further information.
 
-
 .. figure:: img/elliptical_cylinder_angle_definition.png
 
     Definition of the angles for the oriented core_shell_bicelle_elliptical particles.
 
-
+Model verified using Monte Carlo simulation for 1D and 2D scattering.
 
 References
@@ -108,5 +106,5 @@
 * **Author:** Richard Heenan **Date:** December 14, 2016
 * **Last Modified by:**  Richard Heenan **Date:** December 14, 2016
-* **Last Reviewed by:**  Richard Heenan BEWARE 2d data yet to be checked **Date:** December 14, 2016
+* **Last Reviewed by:**  Paul Kienzle **Date:** Feb 28, 2018
 """
 
@@ -130,6 +128,6 @@
 #             ["name", "units", default, [lower, upper], "type", "description"],
 parameters = [
-    ["radius",         "Ang",       30, [0, inf],    "volume",      "Cylinder core radius"],
-    ["x_core",        "None",       3,  [0, inf],    "volume",      "axial ratio of core, X = r_polar/r_equatorial"],
+    ["radius",         "Ang",       30, [0, inf],    "volume",      "Cylinder core radius r_minor"],
+    ["x_core",        "None",       3,  [0, inf],    "volume",      "Axial ratio of core, X = r_major/r_minor"],
     ["thick_rim",  "Ang",            8, [0, inf],    "volume",      "Rim shell thickness"],
     ["thick_face", "Ang",           14, [0, inf],    "volume",      "Cylinder face thickness"],
@@ -139,7 +137,7 @@
     ["sld_rim",        "1e-6/Ang^2", 1, [-inf, inf], "sld",         "Cylinder rim scattering length density"],
     ["sld_solvent",    "1e-6/Ang^2", 6, [-inf, inf], "sld",         "Solvent scattering length density"],
-    ["theta",       "degrees",    90.0, [-360, 360], "orientation", "cylinder axis to beam angle"],
-    ["phi",         "degrees",    0,    [-360, 360], "orientation", "rotation about beam"],
-    ["psi",         "degrees",    0,    [-360, 360], "orientation", "rotation about cylinder axis"]
+    ["theta",       "degrees",    90.0, [-360, 360], "orientation", "Cylinder axis to beam angle"],
+    ["phi",         "degrees",    0,    [-360, 360], "orientation", "Rotation about beam"],
+    ["psi",         "degrees",    0,    [-360, 360], "orientation", "Rotation about cylinder axis"]
     ]
 
Index: sasmodels/models/core_shell_bicelle_elliptical_belt_rough.py
===================================================================
--- sasmodels/models/core_shell_bicelle_elliptical_belt_rough.py	(revision 108e70e22154db937a6d46f66be6dd70408cce6d)
+++ sasmodels/models/core_shell_bicelle_elliptical_belt_rough.py	(revision fc3ae1b048f9f1a5decf2a1e56be7ff62491e36b)
@@ -140,6 +140,6 @@
 #             ["name", "units", default, [lower, upper], "type", "description"],
 parameters = [
-    ["radius",         "Ang",       30, [0, inf],    "volume",      "Cylinder core radius"],
-    ["x_core",        "None",       3,  [0, inf],    "volume",      "axial ratio of core, X = r_polar/r_equatorial"],
+    ["radius",         "Ang",       30, [0, inf],    "volume",      "Cylinder core radius r_minor"],
+    ["x_core",        "None",       3,  [0, inf],    "volume",      "Axial ratio of core, X = r_major/r_minor"],
     ["thick_rim",  "Ang",            8, [0, inf],    "volume",      "Rim or belt shell thickness"],
     ["thick_face", "Ang",           14, [0, inf],    "volume",      "Cylinder face thickness"],
@@ -149,8 +149,8 @@
     ["sld_rim",        "1e-6/Ang^2", 1, [-inf, inf], "sld",         "Cylinder rim scattering length density"],
     ["sld_solvent",    "1e-6/Ang^2", 6, [-inf, inf], "sld",         "Solvent scattering length density"],
-    ["sigma",       "Ang",        0,    [0, inf],    "",            "interfacial roughness"],
-    ["theta",       "degrees",    90.0, [-360, 360], "orientation", "cylinder axis to beam angle"],
-    ["phi",         "degrees",    0,    [-360, 360], "orientation", "rotation about beam"],
-    ["psi",         "degrees",    0,    [-360, 360], "orientation", "rotation about cylinder axis"],
+    ["sigma",       "Ang",        0,    [0, inf],    "",            "Interfacial roughness"],
+    ["theta",       "degrees",    90.0, [-360, 360], "orientation", "Cylinder axis to beam angle"],
+    ["phi",         "degrees",    0,    [-360, 360], "orientation", "Rotation about beam"],
+    ["psi",         "degrees",    0,    [-360, 360], "orientation", "Rotation about cylinder axis"],
     ]
 
Index: sasmodels/models/core_shell_cylinder.c
===================================================================
--- sasmodels/models/core_shell_cylinder.c	(revision 108e70e22154db937a6d46f66be6dd70408cce6d)
+++ sasmodels/models/core_shell_cylinder.c	(revision d86f0fc0fff835c5ddf398e64c046518fa4536fc)
@@ -48,5 +48,6 @@
 
 
-double Iqac(double qab, double qc,
+static double
+Iqac(double qab, double qc,
     double core_sld,
     double shell_sld,
Index: sasmodels/models/hollow_rectangular_prism.c
===================================================================
--- sasmodels/models/hollow_rectangular_prism.c	(revision 108e70e22154db937a6d46f66be6dd70408cce6d)
+++ sasmodels/models/hollow_rectangular_prism.c	(revision d86f0fc0fff835c5ddf398e64c046518fa4536fc)
@@ -1,7 +1,4 @@
-double form_volume(double length_a, double b2a_ratio, double c2a_ratio, double thickness);
-double Iq(double q, double sld, double solvent_sld, double length_a,
-          double b2a_ratio, double c2a_ratio, double thickness);
-
-double form_volume(double length_a, double b2a_ratio, double c2a_ratio, double thickness)
+static double
+form_volume(double length_a, double b2a_ratio, double c2a_ratio, double thickness)
 {
     double length_b = length_a * b2a_ratio;
@@ -16,5 +13,6 @@
 }
 
-double Iq(double q,
+static double
+Iq(double q,
     double sld,
     double solvent_sld,
@@ -85,5 +83,6 @@
 }
 
-double Iqabc(double qa, double qb, double qc,
+static double
+Iqabc(double qa, double qb, double qc,
     double sld,
     double solvent_sld,
Index: sasmodels/models/hollow_rectangular_prism_thin_walls.c
===================================================================
--- sasmodels/models/hollow_rectangular_prism_thin_walls.c	(revision 74768cb764a04223ec9e992e316cb8c211adfe34)
+++ sasmodels/models/hollow_rectangular_prism_thin_walls.c	(revision d86f0fc0fff835c5ddf398e64c046518fa4536fc)
@@ -1,7 +1,4 @@
-double form_volume(double length_a, double b2a_ratio, double c2a_ratio);
-double Iq(double q, double sld, double solvent_sld, double length_a,
-          double b2a_ratio, double c2a_ratio);
-
-double form_volume(double length_a, double b2a_ratio, double c2a_ratio)
+static double
+form_volume(double length_a, double b2a_ratio, double c2a_ratio)
 {
     double length_b = length_a * b2a_ratio;
@@ -11,5 +8,6 @@
 }
 
-double Iq(double q,
+static double
+Iq(double q,
     double sld,
     double solvent_sld,
Index: sasmodels/models/polymer_excl_volume.py
===================================================================
--- sasmodels/models/polymer_excl_volume.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/models/polymer_excl_volume.py	(revision aa900158f288ffb14cd35ce414d65dcc836750dd)
@@ -17,6 +17,17 @@
 $a$ is the statistical segment length of the polymer chain,
 and $n$ is the degree of polymerization.
-This integral was later put into an almost analytical form as follows
+
+This integral was put into an almost analytical form as follows
 (Hammouda, 1993)
+
+.. math::
+
+    P(Q)=\frac{1}{\nu U^{1/2\nu}}
+    \left\{
+        \gamma\left(\frac{1}{2\nu},U\right) -
+        \frac{1}{U^{1/2\nu}}\gamma\left(\frac{1}{\nu},U\right)
+    \right\}
+
+and later recast as (for example, Hore, 2013; Hammouda & Kim, 2017)
 
 .. math::
@@ -29,5 +40,5 @@
 .. math::
 
-    \gamma(x,U)=\int_0^{U}dt\ exp(-t)t^{x-1}
+    \gamma(x,U)=\int_0^{U}dt\ \exp(-t)t^{x-1}
 
 and the variable $U$ is given in terms of the scattering vector $Q$ as
@@ -37,4 +48,14 @@
     U=\frac{Q^2a^2n^{2\nu}}{6} = \frac{Q^2R_{g}^2(2\nu+1)(2\nu+2)}{6}
 
+The two analytic forms are equivalent. In the 1993 paper
+
+.. math::
+
+    \frac{1}{\nu U^{1/2\nu}}
+
+has been factored out.
+
+**SasView implements the 1993 expression**.
+
 The square of the radius-of-gyration is defined as
 
@@ -43,9 +64,10 @@
     R_{g}^2 = \frac{a^2n^{2\nu}}{(2\nu+1)(2\nu+2)}
 
-Note that this model applies only in the mass fractal range (ie, $5/3<=m<=3$ )
-and **does not apply** to surface fractals ( $3<m<=4$ ).
-It also does not reproduce the rigid rod limit (m=1) because it assumes chain
-flexibility from the outset. It may cover a portion of the semi-flexible chain
-range ( $1<m<5/3$ ).
+.. note::
+    This model applies only in the mass fractal range (ie, $5/3<=m<=3$ )
+    and **does not apply** to surface fractals ( $3<m<=4$ ).
+    It also does not reproduce the rigid rod limit (m=1) because it assumes chain
+    flexibility from the outset. It may cover a portion of the semi-flexible chain
+    range ( $1<m<5/3$ ).
 
 A low-Q expansion yields the Guinier form and a high-Q expansion yields the
@@ -73,5 +95,5 @@
 .. math::
 
-    P(Q) = \frac{2}{Q^4R_{g}^4} \left[exp(-Q^2R_{g}^2) - 1 + Q^2R_{g}^2 \right]
+    P(Q) = \frac{2}{Q^4R_{g}^4} \left[\exp(-Q^2R_{g}^2) - 1 + Q^2R_{g}^2 \right]
 
 For 2D data: The 2D scattering intensity is calculated in the same way as 1D,
@@ -89,5 +111,10 @@
 
 B Hammouda, *SANS from Homogeneous Polymer Mixtures - A Unified Overview,
-Advances in Polym. Sci.* 106(1993) 87-133
+Advances in Polym. Sci.* 106 (1993) 87-133
+
+M Hore et al, *Co-Nonsolvency of Poly(n-isopropylacrylamide) in Deuterated
+Water/Ethanol Mixtures* 46 (2013) 7894-7901
+
+B Hammouda & M-H Kim, *The empirical core-chain model* 247 (2017) 434-440
 """
 
@@ -124,4 +151,6 @@
     with errstate(divide='ignore', invalid='ignore'):
         upow = power(usub, -0.5*porod_exp)
+        # Note: scipy gammainc is "regularized", being gamma(s,x)/Gamma(s),
+        # so need to scale by Gamma(s) to recover gamma(s, x).
         result = (porod_exp*upow *
                   (gamma(0.5*porod_exp)*gammainc(0.5*porod_exp, usub) -
Index: sasmodels/models/rectangular_prism.c
===================================================================
--- sasmodels/models/rectangular_prism.c	(revision 108e70e22154db937a6d46f66be6dd70408cce6d)
+++ sasmodels/models/rectangular_prism.c	(revision d86f0fc0fff835c5ddf398e64c046518fa4536fc)
@@ -1,12 +1,10 @@
-double form_volume(double length_a, double b2a_ratio, double c2a_ratio);
-double Iq(double q, double sld, double solvent_sld, double length_a,
-          double b2a_ratio, double c2a_ratio);
-
-double form_volume(double length_a, double b2a_ratio, double c2a_ratio)
+static double
+form_volume(double length_a, double b2a_ratio, double c2a_ratio)
 {
     return length_a * (length_a*b2a_ratio) * (length_a*c2a_ratio);
 }
 
-double Iq(double q,
+static double
+Iq(double q,
     double sld,
     double solvent_sld,
@@ -71,5 +69,6 @@
 
 
-double Iqabc(double qa, double qb, double qc,
+static double
+Iqabc(double qa, double qb, double qc,
     double sld,
     double solvent_sld,
